Loading...
Searching...
No Matches
IRFunctionSRet< SignatureT > Struct Template Reference

Represents a concrete IR function with the first argument as its return type. More...

`#include <openvdb_ax/codegen/FunctionTypes.h>`

Inheritance diagram for IRFunctionSRet< SignatureT >:

## Public Types

using | BaseT = SRetFunction<SignatureT, IRFunction<SignatureT>>
using | Ptr
using | Traits
using | GeneratorCb
| The IR callback function which will write the LLVM IR for this function's body.
enum | SignatureMatch { None = 0 , Size , Implicit , Explicit }
| The result type from calls to Function::match. More...

## Public Member Functions

| IRFunctionSRet (const std::string &symbol, const IRFunctionBase::GeneratorCb &gen)
| ~IRFunctionSRet () override=default
Function::SignatureMatch | match (const std::vector< llvm::Type * > &args, llvm::LLVMContext &C) const override
| Override of match which inserts the SRET type such that the base class methods ignore it.
llvm::Value * | call (const std::vector< llvm::Value * > &args, llvm::IRBuilder<> &B, const bool cast) const override
| Override of call which allocates the required SRET llvm::Value for this function.
void | print (llvm::LLVMContext &C, std::ostream &os, const char *name=nullptr, const bool axTypes=true) const override
| Override of print to avoid printing out the SRET type.
llvm::Type * | types (std::vector< llvm::Type * > &types, llvm::LLVMContext &C) const override
| Populate a vector of llvm::Types which describe this function signature. This method is used by Function::create, Function::print and Function::match.
void | setEmbedIR (bool on)
| Enable or disable the embedding of IR. Embedded IR is currently required for function which use parent function parameters.
bool | hasEmbedIR () const
llvm::Function * | create (llvm::LLVMContext &C, llvm::Module *M) const override
| Override for the creation of an IR function. This ensures that the body and prototype of the function are generated if a Module is provided.
llvm::Function * | create (llvm::Module &M) const
| Convenience method which always uses the provided module to find the function or insert it if necessary.
llvm::Function * | get (const llvm::Module &M) const
| Convenience method for calling M.getFunction(symbol). Returns a nullptr if the function has not yet been created or if it is embedded IR.
size_t | size () const
| The number of arguments that this function has.
const char * | symbol () const
| The function symbol name.
const char * | argName (const size_t idx) const
| Returns the descriptive name of the given argument index.
bool | hasParamAttribute (const size_t i, const llvm::Attribute::AttrKind &kind) const
| Builder methods.
void | setArgumentNames (std::vector< const char * > names)
const std::vector< const char * > & | dependencies () const
void | setDependencies (std::vector< const char * > deps)
void | setFnAttributes (const std::vector< llvm::Attribute::AttrKind > &in)
void | setRetAttributes (const std::vector< llvm::Attribute::AttrKind > &in)
void | setParamAttributes (const size_t i, const std::vector< llvm::Attribute::AttrKind > &in)

## Protected Member Functions

void | verifyResultType (const llvm::Type *result, const llvm::Type *expected) const

## Static Protected Member Functions

static void | cast (std::vector< llvm::Value * > &args, const std::vector< llvm::Type * > &types, llvm::IRBuilder<> &B)
| Cast the provided arguments to the given type as supported by implicit casting of function types. If the types already match OR if a cast cannot be performed, nothing is done to the argument.

## Protected Attributes

const GeneratorCb | mGen
bool | mEmbedIR

## Detailed Description

template<typename SignatureT>
struct openvdb::v10_0::ax::codegen::IRFunctionSRet< SignatureT >

Represents a concrete IR function with the first argument as its return type.

## Member Typedef Documentation

## BaseT

template<typename SignatureT>

using BaseT = SRetFunction<SignatureT, IRFunction<SignatureT>>

## GeneratorCb

using GeneratorCb

inherited

Initial value:
std::function<llvm::Value*
(const std::vector<llvm::Value*>&, llvm::IRBuilder<>&)>

The IR callback function which will write the LLVM IR for this function's body.

The first argument is the vector of functional arguments. i.e. a representation of the value that the callback has been invoked with. The last argument is the IR builder which should be used to generate the function body IR.

Note
  You can return a nullptr from this method which will represent a ret void, a ret void instruction, or an actual value

## Ptr

using Ptr

inherited

## Traits

using Traits

inherited

## Member Enumeration Documentation

## SignatureMatch

enum SignatureMatch

inherited

The result type from calls to Function::match.

Enumerator
None |
Size |
Implicit |
Explicit |

## Constructor & Destructor Documentation

## IRFunctionSRet()

template<typename SignatureT>

IRFunctionSRet | ( | const std::string & | symbol,
|  | const IRFunctionBase::GeneratorCb & | gen )

inline

## ~IRFunctionSRet()

template<typename SignatureT>

~IRFunctionSRet | ( |  | ) |

override default

## Member Function Documentation

## argName()

const char * argName | ( | const size_t | idx | ) | const

inline inherited

Returns the descriptive name of the given argument index.

If the index is greater than the number of arguments, an empty string is returned.

Parameters

  idx | The index of the argument

## call()

llvm::Value * call | ( | const std::vector< llvm::Value * > & | args,
|  | llvm::IRBuilder<> & | B,
|  | const bool | cast ) const

inline override virtual inherited

Override of call which allocates the required SRET llvm::Value for this function.

Note
  Unlike other function where the returned llvm::Value* is a llvm::CallInst (which also represents the return value), SRET functions return the allocated 1st argument i.e. not a llvm::CallInst

Reimplemented from IRFunctionBase.

## cast()

void cast | ( | std::vector< llvm::Value * > & | args,
|  | const std::vector< llvm::Type * > & | types,
|  | llvm::IRBuilder<> & | B )

static protected inherited

Cast the provided arguments to the given type as supported by implicit casting of function types. If the types already match OR if a cast cannot be performed, nothing is done to the argument.

## create() [1/2]

llvm::Function * create | ( | llvm::Module & | M | ) | const

inline inherited

Convenience method which always uses the provided module to find the function or insert it if necessary.

Parameters

  M | The llvm::Module to use

## create() [2/2]

llvm::Function * create | ( | llvm::LLVMContext & | C,
|  | llvm::Module * | M ) const

override virtual inherited

Override for the creation of an IR function. This ensures that the body and prototype of the function are generated if a Module is provided.

Note
  A nullptr is returned if mEmbedIR is true and no action is performed.
  Throws if this function has been initialized with a nullptr generator callback. In this case, the function prototype will be created, but not the function body.
  Throws if the return type of the generator callback does not match the function prototype. In this case, both the prototype and the function body will be created and inserted, but the IR will be invalid.

Reimplemented from Function.

## dependencies()

const std::vector< const char * > & dependencies | ( |  | ) | const

inline inherited

## get()

llvm::Function * get | ( | const llvm::Module & | M | ) | const

inherited

Convenience method for calling M.getFunction(symbol). Returns a nullptr if the function has not yet been created or if it is embedded IR.

Parameters

  M | The llvm::Module to use

## hasEmbedIR()

bool hasEmbedIR | ( |  | ) | const

inline inherited

## hasParamAttribute()

bool hasParamAttribute | ( | const size_t | i,
|  | const llvm::Attribute::AttrKind & | kind ) const

inline inherited

Builder methods.

## match()

Function::SignatureMatch match | ( | const std::vector< llvm::Type * > & | args,
|  | llvm::LLVMContext & | C ) const

inline override virtual inherited

Override of match which inserts the SRET type such that the base class methods ignore it.

Reimplemented from Function.

## print()

void print | ( | llvm::LLVMContext & | C,
|  | std::ostream & | os,
|  | const char * | name = nullptr,
|  | const bool | axTypes = true ) const

inline override virtual inherited

Override of print to avoid printing out the SRET type.

Reimplemented from Function.

## setArgumentNames()

void setArgumentNames | ( | std::vector< const char * > | names | ) |

inline inherited

## setDependencies()

void setDependencies | ( | std::vector< const char * > | deps | ) |

inline inherited

## setEmbedIR()

void setEmbedIR | ( | bool | on | ) |

inline inherited

Enable or disable the embedding of IR. Embedded IR is currently required for function which use parent function parameters.

## setFnAttributes()

void setFnAttributes | ( | const std::vector< llvm::Attribute::AttrKind > & | in | ) |

inline inherited

## setParamAttributes()

void setParamAttributes | ( | const size_t | i,
|  | const std::vector< llvm::Attribute::AttrKind > & | in )

inline inherited

## setRetAttributes()

void setRetAttributes | ( | const std::vector< llvm::Attribute::AttrKind > & | in | ) |

inline inherited

## size()

size_t size | ( |  | ) | const

inline inherited

The number of arguments that this function has.

## symbol()

const char * symbol | ( |  | ) | const

inline inherited

The function symbol name.

This will be used as its identifier in IR and must be unique.

## types()

template<typename SignatureT>

llvm::Type * types | ( | std::vector< llvm::Type * > & | ,
|  | llvm::LLVMContext & | ) const

inline override virtual inherited

Populate a vector of llvm::Types which describe this function signature. This method is used by Function::create, Function::print and Function::match.

Implements Function.

## verifyResultType()

void verifyResultType | ( | const llvm::Type * | result,
|  | const llvm::Type * | expected ) const

inline protected inherited

## Member Data Documentation

## mEmbedIR

bool mEmbedIR

protected inherited

## mGen

const GeneratorCb mGen

protected inherited